<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for associatedRemoteDestinationProfiles StructType
 * @subpackage Structs
 */
class AssociatedRemoteDestinationProfiles extends AbstractStructBase
{
    /**
     * The remoteDestinationProfile
     * Meta informations extracted from the WSDL
     * - documentation: Name of the remoteDestinationProfile
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $remoteDestinationProfile;
    /**
     * Constructor method for associatedRemoteDestinationProfiles
     * @uses AssociatedRemoteDestinationProfiles::setRemoteDestinationProfile()
     * @param string[] $remoteDestinationProfile
     */
    public function __construct(array $remoteDestinationProfile = array())
    {
        $this
            ->setRemoteDestinationProfile($remoteDestinationProfile);
    }
    /**
     * Get remoteDestinationProfile value
     * @return string[]|null
     */
    public function getRemoteDestinationProfile()
    {
        return $this->remoteDestinationProfile;
    }
    /**
     * Set remoteDestinationProfile value
     * @throws \InvalidArgumentException
     * @param string[] $remoteDestinationProfile
     * @return AssociatedRemoteDestinationProfiles
     */
    public function setRemoteDestinationProfile(array $remoteDestinationProfile = array())
    {
        foreach ($remoteDestinationProfile as $associatedRemoteDestinationProfilesRemoteDestinationProfileItem) {
            // validation for constraint: itemType
            if (!is_string($associatedRemoteDestinationProfilesRemoteDestinationProfileItem)) {
                throw new \InvalidArgumentException(sprintf('The remoteDestinationProfile property can only contain items of string, "%s" given', is_object($associatedRemoteDestinationProfilesRemoteDestinationProfileItem) ? get_class($associatedRemoteDestinationProfilesRemoteDestinationProfileItem) : gettype($associatedRemoteDestinationProfilesRemoteDestinationProfileItem)), __LINE__);
            }
        }
        $this->remoteDestinationProfile = $remoteDestinationProfile;
        return $this;
    }
    /**
     * Add item to remoteDestinationProfile value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return AssociatedRemoteDestinationProfiles
     */
    public function addToRemoteDestinationProfile($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The remoteDestinationProfile property can only contain items of string, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->remoteDestinationProfile[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return AssociatedRemoteDestinationProfiles
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
